From 536b8c42b2b1df3747fe44862315927197d14bf7 Mon Sep 17 00:00:00 2001
From: Serghei Mihai <smihai@entrouvert.com>
Date: Thu, 2 Jun 2022 17:32:28 +0200
Subject: [PATCH] add aix marseille theme (#66252)

---
 static/aix-marseille-metropole/_custom.scss   | 178 ++++++++++++++++++
 static/aix-marseille-metropole/_vars.scss     |  63 +++++++
 static/aix-marseille-metropole/config.json    |  15 ++
 .../img/top-cell-bg.svg                       |   1 +
 static/aix-marseille-metropole/style.scss     |   6 +
 5 files changed, 263 insertions(+)
 create mode 100644 static/aix-marseille-metropole/_custom.scss
 create mode 100644 static/aix-marseille-metropole/_vars.scss
 create mode 100644 static/aix-marseille-metropole/config.json
 create mode 100644 static/aix-marseille-metropole/img/top-cell-bg.svg
 create mode 100644 static/aix-marseille-metropole/style.scss

diff --git a/static/aix-marseille-metropole/_custom.scss b/static/aix-marseille-metropole/_custom.scss
new file mode 100644
index 00000000..6f1053b1
--- /dev/null
+++ b/static/aix-marseille-metropole/_custom.scss
@@ -0,0 +1,178 @@
+$title-backgrounds: (
+	"green1": $green1,
+	"green2": $green2,
+	"red": $red,
+	"blue1": $blue1,
+	"blue2": $blue2,
+	"yellow": $yellow,
+	"brown": $brown
+);
+
+%cell {
+	@extend %cell;
+	box-shadow: 0px 6px 56px -12px rgba(12, 29, 24, 0.25);
+}
+
+div#header-wrapper {
+	height: 3.5rem;
+	@media ($max-mobile-viewport) {
+		height: 5rem;
+	}
+}
+
+div#header {
+	padding-left: 0;
+	background: $primary-color;
+	@media ($max-mobile-viewport) {
+		height: 1.5rem;
+	}
+}
+
+.form-content--title {
+	font-size: 41px;
+	text-transform: uppercase;
+	background: transparent;
+}
+
+#toplinks {
+	@media ($min-desktop-viewport) {
+		top: 1rem;
+	}
+	@media ($max-mobile-viewport) {
+		right: 10px;
+	}
+	a {
+		color: white;
+		@media ($max-mobile-viewport) {
+			font-size: 80%;
+		}
+	}
+}
+
+div.gru-nav {
+	> ul {
+		margin-bottom: 0.5rem;
+		display: flex;
+		justify-content: flex-end;
+		> li a {
+			text-transform: uppercase;
+			@media ($min-desktop-viewport) {
+				padding-bottom: 1.5rem;
+			}
+		}
+	}
+	.gru-nav-button {
+		left: calc(100% - #{$nav-menu-side} - 10px);
+		right: 0;
+		top: 0;
+	}
+}
+
+div.gru-nav > ul, .pwa-navigation div > ul {
+	> li a {
+		text-transform: uppercase;
+	}
+}
+
+.pwa-navigation div > ul li {
+	a {
+		font-weight: bold;
+	}
+	&.selected a, &:hover a {
+		  box-shadow: 1px 1px 10px 0px #ddd inset;
+	}
+}
+
+
+#logo.has-logo {
+	width: 140px;
+	height: 60px;
+	padding-left: 0;
+	@media ($max-mobile-viewport) {
+		padding-left: 1rem;
+	}
+	a {
+		position: absolute;
+		z-index: 1;
+		top: 10px;
+		@media ($min-desktop-viewport) {
+			height: 122px;
+		}
+	}
+	&::before {
+		content: '';
+		display: block;
+		height: 0;
+		border-bottom: 4rem solid white;
+		border-right: 4rem solid transparent;
+		width: 15rem;
+		@media ($max-mobile-viewport) {
+			margin-left: -1rem;
+			width: 10rem;
+		}
+	}
+}
+
+div.cell.has-asset-picture {
+	h2:first-child {
+		background: transparent;
+	}
+}
+
+body.has-picture {
+	.combo-placeholder--columns-top {
+		position: absolute;
+		top: -$nav-after-image-height;
+		left: 0;
+		height: $nav-after-image-height;
+		display: flex;
+		justify-content: center;
+		align-items: center;
+		div.cell {
+			padding: 0.5rem 6rem 0.5rem 1rem;
+			background-image: url('img/top-cell-bg.svg');
+			background-position: 95% 75%;
+			background-repeat: no-repeat;
+		}
+	}
+	@media ($max-mobile-viewport) {
+		.site-nav::after {
+			height: $nav-after-image-height / 2;
+		}
+		.combo-placeholder--columns-top {
+			top: 5rem;
+			left: auto;
+			height: $nav-after-image-height / 2;
+		}
+	}
+}
+
+#footer {
+	ul {
+		padding-left: 1rem;
+		li {
+			list-style-type: none;
+		padding: 0.25rem 0;
+		}
+	}
+	h5 {
+		border-bottom: 1px solid;
+	}
+}
+@each $name, $color in $title-backgrounds {
+	div.cell.#{$name}-title {
+		h2:first-child {
+			background: #{$color};
+		}
+	}
+}
+
+/* AUTHENTIC */
+
+.anonymous-user {
+	div.block, div.a2-block {
+		box-shadow: none;
+	}
+}
+
+
diff --git a/static/aix-marseille-metropole/_vars.scss b/static/aix-marseille-metropole/_vars.scss
new file mode 100644
index 00000000..97729d00
--- /dev/null
+++ b/static/aix-marseille-metropole/_vars.scss
@@ -0,0 +1,63 @@
+$primary-color: #0d1d2d;
+$width: 1440px;
+
+$green1: #b4cd1c;
+$green2: #928c1e;
+$red: #e94e1b;
+$blue1: #b0dbd8;
+$blue2: #009fe3;
+$yellow: #fed600;
+$brown: #d6b49d;
+
+$font-color: $primary-color;
+$font-family: 'IBM Plex Serif';
+$font-size: 17px;
+
+$widget-focus-border: 1px solid $primary-color;
+$widget-focus-outline: 1px solid $primary-color;
+$button-focus-outline-offset: 1px;
+
+$button-background: $primary-color;
+
+$nav-button-background: transparent;
+$nav-mobile-bottom-bar-item-hover-background: transparent;
+$nav-mobile-bottom-bar-item-selected-background: $nav-mobile-bottom-bar-item-hover-background;
+
+$nav-item-selected-mode: bottom-border;
+$nav-item-hover: $nav-item-selected-mode;
+$nav-active-color: $red;
+$nav-item-selected-border: 3px solid $nav-active-color;
+$nav-menu-color: $primary-color;
+$nav-border-color: transparent;
+$nav-mobile-menu-item-hover-background: transparent;
+
+$nav-after-image-height: 450px;
+
+$cell-border: none;
+$cell-image-position: top;
+$cell-image-padding: none;
+
+$title-color: $primary-color;
+$title-weight: 700;
+$title-transform: uppercase;
+$title-background: $brown;
+
+$wcs-step-marker-type: disc;
+$wcs-step-border-bottom: none;
+$wcs-step-marker-background: $brown;
+$wcs-step-color: $brown;
+$wcs-step-current-marker-background: $primary-color;
+$wcs-step-current-label-color: $wcs-step-current-marker-background;
+$wcs-step-marker-color: white;
+$wcs-step-current-marker-color: $wcs-step-marker-color;
+$wcs-steps-spacing: 0.7rem;
+
+$buttons-order: previous submit cancel;
+
+$toplinks-style: none;
+
+$link-color: $primary-color;
+
+$footer-background: $primary-color;
+$footer-link-color: white;
+$footer-color: white;
diff --git a/static/aix-marseille-metropole/config.json b/static/aix-marseille-metropole/config.json
new file mode 100644
index 00000000..d1f533fa
--- /dev/null
+++ b/static/aix-marseille-metropole/config.json
@@ -0,0 +1,15 @@
+{
+  "label": "Aix Marseille Métropole",
+  "variables": {
+    "pwa_display": "standalone",
+    "theme_color": "#0d1d2d"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:background": { "label": "Têtière : fond" },
+        "header:logo": { "label": "Têtière : logo" }
+      }
+    }
+  }
+}
diff --git a/static/aix-marseille-metropole/img/top-cell-bg.svg b/static/aix-marseille-metropole/img/top-cell-bg.svg
new file mode 100644
index 00000000..00eafae1
--- /dev/null
+++ b/static/aix-marseille-metropole/img/top-cell-bg.svg
@@ -0,0 +1 @@
+<svg version="1.2" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" overflow="visible" preserveAspectRatio="none" viewBox="0 0 79 91" width="79" height="91"><g transform="translate(0, 0)"><g transform="translate(8.881784197001252e-16, 2.220446049250313e-16) rotate(0)"><path style="stroke-width: 0px; stroke-linecap: butt; stroke-linejoin: miter; fill: rgb(244, 156, 108);" d="M20.40282,50.06597l0.00812,2.29612l-5.90886,5.88179l-2.31481,-2.30421l5.90886,-5.87775zM2.31481,50.06193l6.29466,5.88179l-2.31075,2.30016l-6.29872,-5.87775v-0.48105l0.00406,-1.81911zM14.50208,61.80934l5.90886,5.88179l-0.00812,2.29612l-2.31075,0.00808l-5.9048,-5.88179zM6.29872,61.80934l2.31481,2.30421l-5.90886,5.88179l-2.31075,-0.00808l-0.00406,-2.29612zM78.99594,81.80743l0.00406,1.05913l-2.72498,2.7125l-1.06806,-1.06317l2.72498,-2.7125zM73.55817,84.51588l-1.06806,1.06317l-2.90773,-2.7125v-0.08085l0.00406,-0.97828l1.064,-0.00404zM76.27502,87.22433l2.72498,2.7125l-0.00406,1.05913l-0.80003,0.00404h-0.26397l-2.72498,-2.7125zM72.4901,87.22433l1.06806,1.05913l-2.72498,2.7125h-1.06806v-1.05913zM47.55513,0v0.73573l-1.8884,1.87975l-0.73911,-0.73573l1.8884,-1.87975zM43.7824,1.87975l-0.73911,0.73573l-2.01429,-1.87975v-0.73573h0.73911zM45.66674,3.75545l1.8884,1.87975l-0.00406,0.73573h-0.73505l-1.8884,-1.87975zM43.04328,3.75545l0.73911,0.73573l-1.8884,1.88379l-0.73911,-0.00404v-0.73573z" vector-effect="non-scaling-stroke"/></g><defs><path id="path-1654866533015799" d="M20.40282,50.06597l0.00812,2.29612l-5.90886,5.88179l-2.31481,-2.30421l5.90886,-5.87775zM2.31481,50.06193l6.29466,5.88179l-2.31075,2.30016l-6.29872,-5.87775v-0.48105l0.00406,-1.81911zM14.50208,61.80934l5.90886,5.88179l-0.00812,2.29612l-2.31075,0.00808l-5.9048,-5.88179zM6.29872,61.80934l2.31481,2.30421l-5.90886,5.88179l-2.31075,-0.00808l-0.00406,-2.29612zM78.99594,81.80743l0.00406,1.05913l-2.72498,2.7125l-1.06806,-1.06317l2.72498,-2.7125zM73.55817,84.51588l-1.06806,1.06317l-2.90773,-2.7125v-0.08085l0.00406,-0.97828l1.064,-0.00404zM76.27502,87.22433l2.72498,2.7125l-0.00406,1.05913l-0.80003,0.00404h-0.26397l-2.72498,-2.7125zM72.4901,87.22433l1.06806,1.05913l-2.72498,2.7125h-1.06806v-1.05913zM47.55513,0v0.73573l-1.8884,1.87975l-0.73911,-0.73573l1.8884,-1.87975zM43.7824,1.87975l-0.73911,0.73573l-2.01429,-1.87975v-0.73573h0.73911zM45.66674,3.75545l1.8884,1.87975l-0.00406,0.73573h-0.73505l-1.8884,-1.87975zM43.04328,3.75545l0.73911,0.73573l-1.8884,1.88379l-0.73911,-0.00404v-0.73573z" vector-effect="non-scaling-stroke"/></defs></g></svg>
\ No newline at end of file
diff --git a/static/aix-marseille-metropole/style.scss b/static/aix-marseille-metropole/style.scss
new file mode 100644
index 00000000..f2a075ff
--- /dev/null
+++ b/static/aix-marseille-metropole/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+
+@import '../includes/fonts/ibm-plex-serif';
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.36.1